//这种注释会在java代码中读取时去掉.不要用别的注释.
(function() {
    if (window.WebViewJavascriptBridge) {
        return;
    }
    //js自己添加的messageHandler
    var messageHandlers = {};
    //js调用native时,自己保存一个callback列表,用于native执行完毕后数据回传
    var responseCallbacks = {};
    //自增id
    var uniqueId = 1;

    //设置默认的messageHandler,基本用不上
    function init(messageHandler) {
        if (WebViewJavascriptBridge._messageHandler) {
            //throw new Error('WebViewJavascriptBridge.init called twice');//在h5页面初始化时,如果并发调用js方法,会报错.这里去掉报错提示,同时对后面代码做修改.
        }
        WebViewJavascriptBridge._messageHandler = messageHandler;
    }

    //用于js自己注册方法,给native调用
    function registerHandler(handlerName, handler) {
        messageHandlers[handlerName] = handler;
    }

    //jssdk调用native的核心方法.
    function callHandler(handlerName, data, responseCallback) {
        _doSend({
            handlerName: handlerName,
            data: data
        }, responseCallback);
    }

    //把responseCallback保存下来并得到一个id,再传递给native.
    function _doSend(message, responseCallback) {
        if (responseCallback) {
            var callbackId = 'cb_' + (uniqueId++) + '_' + new Date().getTime();
            responseCallbacks[callbackId] = responseCallback;
            message.callbackId = callbackId;
        }
        if(typeof message.data == 'object'){
            jsobj.callNative(message.handlerName,JSON.stringify(message.data),message.callbackId);
        }else{
            jsobj.callNative(message.handlerName,message.data,message.callbackId);
        }
    }

    //处理native那边发送过来的消息.将json类型的string转为message数据体
    function _dispatchMessageFromNative(messageJSON) {
        setTimeout(function() {
            var message = JSON.parse(messageJSON);
            var responseCallback;
            if (message.responseId) {
                //有responseId说明这是js调用native方法,native这边执行完毕后,根据responseId回传给js的.
                responseCallback = responseCallbacks[message.responseId];
                if (!responseCallback) {
                    return;
                }
                responseCallback(message.responseData);
                delete responseCallbacks[message.responseId];
            } else {
                //没有responseId,说明是native主动调用js方法的.
                if (message.callbackId) {
                    //有callbackid,说明希望js执行后还有个回调.
                    var callbackResponseId = message.callbackId;
                    responseCallback = function(responseData) {
                        _doSend({
                            responseId: callbackResponseId,
                            responseData: responseData
                        });
                    };
                }
                //如果没有指定handlername,会由WebViewJavascriptBridge的init方法传入的默认handler来处理.
                var handler = WebViewJavascriptBridge._messageHandler;
                if (message.handlerName) {
                    //有handlerName说明native那边已经指定了js注册的某个handler来执行.
                    handler = messageHandlers[message.handlerName];
                }
                //下面这段代码其实只需要判断handler是否为null就行了.但是catch住不为null的异常并打印出来也行
                try {
                    handler(message.data, responseCallback);
                } catch (exception) {
                    if (typeof console != 'undefined') {
                        console.log("WebViewJavascriptBridge: WARNING: javascript handler threw.", message, exception);
                    }
                }
            }
        });
    }

    //提供给native调用.native发送消息会调用这个方法
    function _handleMessageFromNative(messageJSON) {
        console.log(messageJSON);
        _dispatchMessageFromNative(messageJSON);
    }

    var WebViewJavascriptBridge = window.WebViewJavascriptBridge = {
        init: init,
        registerHandler: registerHandler,
        callHandler: callHandler,
        _handleMessageFromNative: _handleMessageFromNative
    };

    var doc = document;
    var readyEvent = doc.createEvent('Events');
    readyEvent.initEvent('WebViewJavascriptBridgeReady');
    readyEvent.bridge = WebViewJavascriptBridge;
    doc.dispatchEvent(readyEvent);
})();